﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim AResource1 As AndroidResources
End Sub

Sub Globals
	Dim img1,img2,img3,img4,img5,img6,img7, ImgWind As ImageView
	Dim lb1,lb2,lb3,lb4,lb5,lb6,lb7,lb8,bb2 As Label
	Dim lb9,lb10,lb11,lb12,lb13,lb14,lb15,lb16,lb17,lb18,lb19 As Label
	Dim l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12 As Label
	Dim mSecondary As Boolean
	Dim WeatherDays() As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.AddMenuItem(AResource1.GetApplicationString("BackMenuItem"),"back")
	Activity.AddMenuItem(AResource1.GetApplicationString("UpdateMenuItem"),"Update")
	If Main.mBoolean = False AND Main.mGetList.Length > 0 Then
		Main.a.CityName=Main.mGetList		
		Weather	
	Else If Main.mBoolean = True AND Main.mCityname.Length > 0 Then
		Main.a.CityName=Main.mCityname		
		Weather	
	End If
End Sub

Sub Activity_Resume
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean	'return true if you want to consume the event
    If KeyCode = KeyCodes.KEYCODE_BACK Then
		If mSecondary Then
			mSecondary = False
			Activity.RemoveAllViews
			Weather
			Return True
        Else
            Return False
        End If
    Else
		Return False
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Weather
	If Main.a.isWiFiConnected = True Then 
		Activity.LoadLayout("icosforecast")
		lb1.Text= Main.a.AreaName & ", " & Main.a.Region & ", " & Main.a.Country
		lb13.Text=Main.a.CurrentDate&" - "&Main.a.CurrentTime
		lb2.Text=AResource1.GetApplicationString("CCObservationTime")&Main.a.CCObservationTime
		bb2.Text=AResource1.GetApplicationString("CCLocalObsDateTime")&Main.a.CCLocalObsDateTime
		lb3.Text=Main.a.CCTempCelsius&"°"
		Dim CCCode As Int
		Dim tmpDescr As String
		CCCode = Main.a.CCWeatherCode
		tmpDescr = AResource1.GetApplicationString("Code"&CCCode)
		If tmpDescr.Contains("/") Then
			Dim tmpHours As Int
			Dim tmpStrHours1, tmpStrHours2 As String
			tmpStrHours1 = Main.a.CurrentTime
			tmpStrHours2 = tmpStrHours1.SubString2(0,tmpStrHours1.IndexOf("."))
			tmpHours = tmpStrHours2
			If tmpHours < 7 OR tmpHours > 21 Then
				lb4.Text=tmpDescr.SubString2(0,tmpDescr.IndexOf("/"))
			Else
				lb4.Text=tmpDescr.SubString(tmpDescr.IndexOf("/")+1)
			End If
		Else
			lb4.Text=tmpDescr
		End If
		lb15.Text=Main.a.StringFormat("Lat: %1$s Long: %2$s ",Main.a.Latitude,Main.a.Longitude)
		lb5.Text= AResource1.GetApplicationString("CCHumidity") & Main.a.CCHumidity & "%"
		lb6.Text= AResource1.GetApplicationString("CCPressure") & Main.a.CCPressure & " hPa"
		lb7.Text= AResource1.GetApplicationString("CCVisibility") & Main.a.CCVisibility & " Km"
		lb8.Text= AResource1.GetApplicationString("CCWinddir16Point") & Main.a.CCWinddir16Point
		lb12.Text= AResource1.GetApplicationString("CCWinddirDegree") & Main.a.CCWinddirDegree&"°"
		lb9.Text= AResource1.GetApplicationString("CCWindspeedHead") & Main.a.CCWindspeedKmph & " " & AResource1.GetApplicationString("CCWindspeedKmph")
		lb10.Text= AResource1.GetApplicationString("CCCloudCover") & Main.a.CCCloudCover & "%"
		lb11.Text= AResource1.GetApplicationString("CCPrecipitationMM") & Main.a.CCPrecipitationMM & " MM"
		lb14.Text= AResource1.GetApplicationString("CCPopulation") & Main.a.Population
		lb16.Text= AResource1.GetApplicationString("CCTimeZoneID") & Main.a.TimeZoneID
		lb17.text= "GMT: "  &Main.a.GmtOffset & " - DstOffset: " & Main.a.DstOffset
		lb18.text= AResource1.GetApplicationString("CCSunrise") & Main.a.Sunrise
		lb19.text= AResource1.GetApplicationString("CCSunset") & Main.a.Sunset
		
		img1.Bitmap=Main.a.CCIcon
		img2.Bitmap=Main.a.FCIcon(1)
		img3.Bitmap=Main.a.FCIcon(2)
		img4.Bitmap=Main.a.FCIcon(3)
		img5.Bitmap=Main.a.FCIcon(4)
		img6.Bitmap=Main.a.FCIcon(5)
		img7.Bitmap=Main.a.FCIcon(6)
		RotateView(ImgWind,ImgWind.Bitmap,Main.a.CCWinddirDegree)
		Try
			Log("This day Full7DayName of library is : " & Main.a.Full7DayName(0))
			l1.Text=Main.a.Full7DayName(1)&CRLF&Main.a.FCDate(1)
			l1.Text=Main.a.Full7DayName(1)&CRLF&Main.a.FCDate(1)
			l3.Text=Main.a.Full7DayName(2)&CRLF&Main.a.FCDate(2)
			l5.Text=Main.a.Full7DayName(3)&CRLF&Main.a.FCDate(3)
			l7.Text=Main.a.Full7DayName(4)&CRLF&Main.a.FCDate(4)
			l9.Text=Main.a.Full7DayName(5)&CRLF&Main.a.FCDate(5)
			l11.Text=Main.a.Full7DayName(6)&CRLF&Main.a.FCDate(6)
			Log("Library give the Full7DayName normally")
		Catch
			Full7DayName(Main.a.FCDate(0))
			Log("WeatherDays lenght is " & WeatherDays.Length)
			Log("WeatherDays " & WeatherDays(0) & _
							" " & WeatherDays(1) & _
							" " & WeatherDays(2) & _
							" " & WeatherDays(3) & _
							" " & WeatherDays(4) & _
							" " & WeatherDays(5) & _
							" " & WeatherDays(6))
			l1.Text=WeatherDays(1)&CRLF&Main.a.FCDate(1)
			l1.Text=WeatherDays(1)&CRLF&Main.a.FCDate(1)
			l3.Text=WeatherDays(2)&CRLF&Main.a.FCDate(2)
			l5.Text=WeatherDays(3)&CRLF&Main.a.FCDate(3)
			l7.Text=WeatherDays(4)&CRLF&Main.a.FCDate(4)
			l9.Text=WeatherDays(5)&CRLF&Main.a.FCDate(5)
			l11.Text=WeatherDays(6)&CRLF&Main.a.FCDate(6)
		End Try
	
		l2.Text=Main.a.FCTempMaxCelsius(1)&"° / "&Main.a.FCTempMinCelsius(1)&"°"
		l4.Text=Main.a.FCTempMaxCelsius(2)&"° / "&Main.a.FCTempMinCelsius(2)&"°"
		l6.Text=Main.a.FCTempMaxCelsius(3)&"° / "&Main.a.FCTempMinCelsius(3)&"°"
		l8.Text=Main.a.FCTempMaxCelsius(4)&"° / "&Main.a.FCTempMinCelsius(4)&"°"
		l10.Text=Main.a.FCTempMaxCelsius(5)&"° / "&Main.a.FCTempMinCelsius(5)&"°"
		l12.Text=Main.a.FCTempMaxCelsius(6)&"° / "&Main.a.FCTempMinCelsius(6)&"°"
	
	Else
		Activity.Finish
	End If
End Sub

Sub Update_click
	Weather
End Sub

Sub back_click
	If mSecondary Then
		mSecondary = False
		Activity.RemoveAllViews
		Weather
	Else
		Activity.Finish
	End If
End Sub

Sub img_Click
	Dim b As Int, Send As View
	'Affect the variables
	Send=Sender
	b=Send.Tag
	mSecondary = True
	LoadsecondaryLayout(b)
End Sub

Sub LoadsecondaryLayout(thisForecast As Int)
		Activity.RemoveAllViews
		Activity.LoadLayout("SecondaryForecast")
		lb1.Text=Main.a.AreaName & ", " & Main.a.Region & ", " & Main.a.Country
		Try
			Log("Library give the Full7DayName normally")
			lb13.Text=Main.a.Full7DayName(thisForecast)&" "&Main.a.FCDate(thisForecast)
		Catch
			Log("WeatherDays lenght is " & WeatherDays.Length)
			Log("WeatherDays " & WeatherDays(thisForecast))
			lb13.Text=WeatherDays(thisForecast)&" "&Main.a.FCDate(thisForecast)
		End Try
		lb2.Text=AResource1.GetApplicationString("FCTempMaxCelsius") & Main.a.FCTempMaxCelsius(thisForecast) & "°"
		bb2.Text=AResource1.GetApplicationString("FCTempMinCelsius") & Main.a.FCTempMinCelsius(thisForecast) & "°"
		Dim CCCode As Int
		Dim tmpDescr As String
		CCCode = Main.a.FCWeatherCode(thisForecast)
		tmpDescr = AResource1.GetApplicationString("Code"&CCCode)
		If tmpDescr.Contains("/") Then
			Dim tmpHours As Int
			Dim tmpStrHours1, tmpStrHours2 As String
			tmpStrHours1 = Main.a.CurrentTime
			tmpStrHours2 = tmpStrHours1.SubString2(0,tmpStrHours1.IndexOf("."))
			tmpHours = tmpStrHours2
			If tmpHours < 8 OR tmpHours > 23 Then
				lb4.Text=tmpDescr.SubString2(0,tmpDescr.IndexOf("/"))
			Else
				lb4.Text=tmpDescr.SubString(tmpDescr.IndexOf("/")+1)
			End If
		Else
			lb4.Text=tmpDescr
		End If
		lb15.Text=Main.a.StringFormat("Lat: %1$s Long: %2$s ",Main.a.Latitude,Main.a.Longitude)
		lb8.Text= AResource1.GetApplicationString("CCWinddir16Point") & Main.a.FCWinddir16Point(thisForecast)
		lb12.Text= AResource1.GetApplicationString("CCWinddirDegree") & Main.a.FCWinddirDegree(thisForecast)&"°"
		lb9.Text= AResource1.GetApplicationString("CCWindspeedHead") & Main.a.FCWindspeedKmph(thisForecast) & " " & AResource1.GetApplicationString("CCWindspeedKmph")
		lb11.Text= AResource1.GetApplicationString("CCPrecipitationMM") & Main.a.FCPrecipitationMM(thisForecast) & " MM"
		lb14.Text= AResource1.GetApplicationString("CCPopulation") & Main.a.Population
		lb16.Text= AResource1.GetApplicationString("CCTimeZoneID") & Main.a.TimeZoneID
		lb17.text= "GMT: "  &Main.a.GmtOffset & " - DstOffset: " & Main.a.DstOffset
		img1.Bitmap=Main.a.FCIcon(thisForecast)
		RotateView(ImgWind,ImgWind.Bitmap,Main.a.FCWinddirDegree(thisForecast))
End Sub

Sub RotateView(v As View, bmp As Bitmap, degrees As Int)
    Dim c As Canvas
    Dim r As Rect
    c.Initialize(v)
    r.Initialize(0,0,v.Width,v.Height)
    c.DrawRect(r,Colors.transparent,True,0)
    c.DrawBitmapRotated(bmp,Null,r,degrees)
    v.Invalidate
End Sub

Sub Full7DayName(Firstdate As String)
	Dim mLocale As AHLocale
	mLocale.Initialize
	Dim tmpMonth, tmpMonth2 As String
	Dim mDay, mMonth, mYear As Int
	Dim testNotMonthFirst As Boolean
	testNotMonthFirst = Firstdate.IndexOf(" ") = 2
	If testNotMonthFirst Then	'That means that the date is in french format (dd MMM) not english format
		mDay = Firstdate.SubString2(0,2)
		tmpMonth2 = Firstdate.SubString2(3,Firstdate.Length-1)
	Else
		mDay = Firstdate.SubString(Firstdate.IndexOf(" ")+1)
		tmpMonth2 = Firstdate.SubString2(0,Firstdate.IndexOf(" "))
	End If
	tmpMonth = tmpMonth2.ToLowerCase
	Select Case tmpMonth
		Case "janu", "janv"
			mMonth = 1
		Case "febr", "févr"
			mMonth = 2
		Case "mars", "marc"
			mMonth = 3
		Case "avri", "apri"
			mMonth = 4
		Case "may", "mai"
			mMonth = 5
		Case "june", "juin"
			mMonth = 6
		Case "july", "juil"
			mMonth = 7
		Case "augu", "août"
			mMonth = 8
		Case "sept"
			mMonth = 9
		Case "octo"
			mMonth = 10
		Case "nove"
			mMonth = 11
		Case "dece", "déce"
			mMonth = 12
	End Select
	mYear = DateTime.GetYear(DateTime.Now)
	Dim tmpDay As Int
	tmpDay = DateTime.GetDayOfWeek(DateTime.DateParse(mMonth & "/" & mDay & "/" & mYear))
	Select Case tmpDay
		Case 1
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay+2), _
										mLocale.WeekDays(tmpDay+3), _
										mLocale.WeekDays(tmpDay+4), _
										mLocale.WeekDays(tmpDay+5), _
										mLocale.WeekDays(tmpDay+6))
		Case 2
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay+2), _
										mLocale.WeekDays(tmpDay+3), _
										mLocale.WeekDays(tmpDay+4), _
										mLocale.WeekDays(tmpDay+5), _
										mLocale.WeekDays(tmpDay-1))
		Case 3
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay+2), _
										mLocale.WeekDays(tmpDay+3), _
										mLocale.WeekDays(tmpDay+4), _
										mLocale.WeekDays(tmpDay-2), _
										mLocale.WeekDays(tmpDay-1))
		Case 4
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay+2), _
										mLocale.WeekDays(tmpDay+3), _
										mLocale.WeekDays(tmpDay-3), _
										mLocale.WeekDays(tmpDay-2), _
										mLocale.WeekDays(tmpDay-1))
		Case 5
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay+2), _
										mLocale.WeekDays(tmpDay-4), _
										mLocale.WeekDays(tmpDay-3), _
										mLocale.WeekDays(tmpDay-2), _
										mLocale.WeekDays(tmpDay-1))
		Case 6
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay+1), _
										mLocale.WeekDays(tmpDay-5), _
										mLocale.WeekDays(tmpDay-4), _
										mLocale.WeekDays(tmpDay-3), _
										mLocale.WeekDays(tmpDay-2), _
										mLocale.WeekDays(tmpDay-1))
		Case 7			
			WeatherDays = Array As String(mLocale.WeekDays(tmpDay), _
										mLocale.WeekDays(tmpDay-6), _
										mLocale.WeekDays(tmpDay-5), _
										mLocale.WeekDays(tmpDay-4), _
										mLocale.WeekDays(tmpDay-3), _
										mLocale.WeekDays(tmpDay-2), _
										mLocale.WeekDays(tmpDay-1))
	End Select
End Sub